import{s as Pt,n as It,o as Ut}from"../chunks/scheduler.048ce5c2.js";import{S as At,i as Gt,g as s,s as o,r as h,A as Ft,h as l,f as i,c as a,j as Ht,u as f,x as r,k as Mt,y as Ot,a as n,v as m,d,t as p,w as g}from"../chunks/index.2633050f.js";import{H as u}from"../chunks/Heading.bb054f8c.js";function jt(Qe){let c,le,ae,re,b,he,w,Ze="Welcome to Unit 3 of the Hugging Face Diffusion Models Course! In this unit you will meet a powerful diffusion model called Stable Diffusion (SD) and explore what it can do.",fe,v,me,y,et="Here are the steps for this unit:",de,x,tt='<li>Make sure you’ve <a href="https://huggingface.us17.list-manage.com/subscribe?u=7f57e683fa28b51bfc493d048&amp;id=ef963b4162" rel="nofollow">signed up for this course</a> so that you can be notified when new material is released.</li> <li>Read through the material below for an overview of the key ideas of this unit.</li> <li>Check out the <a href="#hands-on-notebook"><em><strong>Stable Diffusion Introduction</strong></em> notebook</a> to see SD applied in practice to some common use-cases.</li> <li>Use the <em><strong>Dreambooth</strong></em> notebook in the <a href="https://github.com/huggingface/diffusion-models-class/tree/main/hackathon" rel="nofollow"><strong>hackathon</strong> folder</a> to fine-tune your own custom Stable Diffusion model and share it with the community for a chance to win some prizes and swag.</li> <li>(Optional) Check out the <a href="https://www.youtube.com/watch?app=desktop&amp;v=0_BBRNYInx8" rel="nofollow"><em><strong>Stable Diffusion Deep Dive video</strong></em></a> and the accompanying <a href="https://github.com/fastai/diffusion-nbs/blob/master/Stable%20Diffusion%20Deep%20Dive.ipynb" rel="nofollow"><em><strong>notebook</strong></em></a> for a deeper exploration of the different components and how they can be adapted for different effects. This material was created for the new FastAI course, <a href="https://www.fast.ai/posts/part2-2022.html" rel="nofollow">‘Stable Diffusion from the Foundations’</a> - the whole course has been released, making this a great supplement to this class for anyone curious about building these kinds of models completely from scratch.</li>',pe,k,it=':loudspeaker: Don’t forget to join the <a href="https://huggingface.co/join/discord" rel="nofollow">Discord</a>, where you can discuss the material and share what you’ve made in the <code>#diffusion-models-class</code> channel.',ge,$,ue,T,nt='<img src="sd_demo_images.jpg" alt="SD example images"/><br/> <em>Example images generated using Stable Diffusion</em>',ce,C,ot="Stable Diffusion is a powerful text-conditioned latent diffusion model. Don’t worry, we’ll explain those words shortly! Its ability to create amazing images from text descriptions has made it an internet sensation. In this unit, we’re going to explore how SD works and see what other tricks it can do.",be,D,we,_,at="As image size grows, so does the computational power required to work with those images. This is especially pronounced in an operation called self-attention, where the amount of operations grows quadratically with the number of inputs. A 128px square image has 4x as many pixels as a 64px square image, and so requires 16x (i.e. 4<sup>2</sup>) the memory and compute in a self-attention layer. This is a problem for anyone who’d like to generate high-resolution images!",ve,L,st='<img src="https://github.com/CompVis/latent-diffusion/raw/main/assets/modelfigure.png" alt="latent diffusion diagram"/><br/> <em>Diagram from the <a href="http://arxiv.org/abs/2112.10752" rel="nofollow">Latent Diffusion paper</a></em>',ye,S,lt="Latent diffusion helps to mitigate this issue by using a separate model called a Variational Auto-Encoder (VAE) to <strong>compress</strong> images to a smaller spatial dimension. The rationale behind this is that images tend to contain a large amount of redundant information - given enough training data, a VAE can hopefully learn to produce a much smaller representation of an input image and then reconstruct the image based on this small <strong>latent</strong> representation with a high degree of fidelity. The VAE used in SD takes in 3-channel images and produces a 4-channel latent representation with a reduction factor of 8 for each spatial dimension. That is, a 512px square input image will be compressed down to a 4x64x64 latent.",xe,H,rt="By applying the diffusion process on these <strong>latent representations</strong> rather than on full-resolution images, we can get many of the benefits that would come from using smaller images (lower memory usage, fewer layers needed in the UNet, faster generation times…) and still decode the result back to a high-resolution image once we’re ready to view the final result. This innovation dramatically lowers the cost to train and run these models.",ke,M,$e,P,ht="In Unit 2 we showed how feeding additional information to the UNet allows us to have some additional control over the types of images generated. We call this conditioning. Given a noisy version of an image, the model is tasked with predicting the denoised version <strong>based on additional clues</strong> such as a class label or, in the case of Stable Diffusion, a text description of the image. At inference time, we can feed in the description of an image we’d like to see and some pure noise as a starting point, and the model does its best to ‘denoise’ the random input into something that matches the caption.",Te,I,ft='<img src="text_encoder_noborder.png" alt="text encoder diagram"/><br/> <em>Diagram showing the text encoding process which transforms the input prompt into a set of text embeddings (the encoder_hidden_states) which can then be fed in as conditioning to the UNet.</em>',Ce,U,mt="For this to work, we need to create a numeric representation of the text that captures relevant information about what it describes. To do this, SD leverages a pre-trained transformer model based on something called CLIP. CLIP’s text encoder was designed to process image captions into a form that could be used to compare images and text, so it is well suited to the task of creating useful representations from image descriptions. An input prompt is first tokenized (based on a large vocabulary where each word or sub-word is assigned a specific token) and then fed through the CLIP text encoder, producing a 768-dimensional (in the case of SD 1.X) or 1024-dimensional (SD 2.X) vector for each token. To keep things consistent prompts are always padded/truncated to be 77 tokens long, and so the final representation which we use as conditioning is a tensor of shape 77x1024 per prompt.",De,A,dt='<img src="sd_unet_color.png" alt="conditioning diagram"/>',_e,G,pt="OK, so how do we actually feed this conditioning information into the UNet for it to use as it makes predictions? The answer is something called cross-attention. Scattered throughout the UNet are cross-attention layers. Each spatial location in the UNet can ‘attend’ to different tokens in the text conditioning, bringing in relevant information from the prompt. The diagram above shows how this text conditioning (as well as timestep-based conditioning) is fed in at different points. As you can see, at every level the UNet has ample opportunity to make use of this conditioning!",Le,F,Se,O,gt="It turns out that even with all of the effort put into making the text conditioning as useful as possible, the model still tends to default to relying mostly on the noisy input image rather than the prompt when making its predictions. In a way, this makes sense - many captions are only loosely related to their associated images and so the model learns not to rely too heavily on the descriptions! However, this is undesirable when it comes time to generate new images - if the model doesn’t follow the prompt then we may get images out that don’t relate to our description at all.",He,j,ut='<img src="cfg_example_0_1_2_10.jpeg" alt="CFG scale demo grid"/><br/> <em>Images generated from the prompt “An oil painting of a collie in a top hat” with CFG scale 0, 1, 2 and 10 (left to right)</em>',Me,q,ct="To fix this, we use a trick called Classifier-Free Guidance (CGF). During training, text conditioning is sometimes kept blank, forcing the model to learn to denoise images with no text information whatsoever (unconditional generation). Then at inference time, we make two separate predictions: one with the text prompt as conditioning and one without. We can then use the difference between these two predictions to create a final combined prediction that pushes <strong>even further</strong> in the direction indicated by the text-conditioned prediction according to some scaling factor (the guidance scale), hopefully resulting in an image that better matches the prompt. The image above shows the outputs for a prompt at different guidance scales - as you can see, higher values result in images that better match the description.",Pe,E,Ie,N,bt='It is possible to create versions of Stable Diffusion that take in additional kinds of conditioning. For example, the <a href="https://huggingface.co/stabilityai/stable-diffusion-2-depth" rel="nofollow">Depth-to-Image model</a> has extra input channels that take in-depth information about the image being denoised, and at inference time we can feed in the depth map of a target image (estimated using a separate model) to hopefully generate an image with a similar overall structure.',Ue,z,wt='<img src="https://huggingface.co/stabilityai/stable-diffusion-2-depth/resolve/main/depth2image.png" alt="depth to image example"/><br/> <em>Depth-conditioned SD is able to generate different images with the same overall structure (example from StabilityAI)</em>',Ae,B,vt='In a similar manner, we can feed in a low-resolution image as the conditioning and have the model generate the high-resolution version (<a href="https://huggingface.co/stabilityai/stable-diffusion-x4-upscaler" rel="nofollow">as used by the Stable Diffusion Upscaler</a>). Finally, we can feed in a mask showing a region of the image to be re-generated as part of the ‘in-painting’ task, where the non-mask regions need to stay intact while new content is generated for the masked area.',Ge,R,Fe,K,yt='<img src="https://dreambooth.github.io/DreamBooth_files/teaser_static.jpg" alt="dreambooth diagram"/> <em>Image from the <a href="https://dreambooth.github.io/" rel="nofollow">dreambooth project page</a> based on the Imagen model</em>',Oe,V,xt='DreamBooth is a technique for fine-tuning a text-to-image model to ‘teach’ it a new concept, such as a specific object or style. The technique was originally developed for Google’s Imagen model but was quickly adapted to <a href="https://huggingface.co/docs/diffusers/training/dreambooth" rel="nofollow">work for stable diffusion</a>. Results can be extremely impressive (if you’ve seen anyone with an AI profile picture on social media recently the odds are high it came from a dreambooth-based service) but the technique is also sensitive to the settings used, so check out our notebook and <a href="https://huggingface.co/blog/dreambooth" rel="nofollow">this great investigation into the different training parameters</a> for some tips on getting it working as well as possible.',je,W,qe,X,kt='<thead><tr><th align="left">Chapter</th> <th align="left">Colab</th> <th align="left">Kaggle</th> <th align="left">Gradient</th> <th align="left">Studio Lab</th></tr></thead> <tbody><tr><td align="left">Stable Diffusion Introduction</td> <td align="left"><a href="https://colab.research.google.com/github/huggingface/diffusion-models-class/blob/main/unit3/01_stable_diffusion_introduction.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td> <td align="left"><a href="https://kaggle.com/kernels/welcome?src=https://github.com/huggingface/diffusion-models-class/blob/main/unit3/01_stable_diffusion_introduction.ipynb" rel="nofollow"><img src="https://kaggle.com/static/images/open-in-kaggle.svg" alt="Kaggle"/></a></td> <td align="left"><a href="https://console.paperspace.com/github/huggingface/diffusion-models-class/blob/main/unit3/01_stable_diffusion_introduction.ipynb" rel="nofollow"><img src="https://assets.paperspace.io/img/gradient-badge.svg" alt="Gradient"/></a></td> <td align="left"><a href="https://studiolab.sagemaker.aws/import/github/huggingface/diffusion-models-class/blob/main/unit3/01_stable_diffusion_introduction.ipynb" rel="nofollow"><img src="https://studiolab.sagemaker.aws/studiolab.svg" alt="Open In SageMaker Studio Lab"/></a></td></tr> <tr><td align="left">DreamBooth Hackathon Notebook</td> <td align="left"><a href="https://colab.research.google.com/github/huggingface/diffusion-models-class/blob/main/hackathon/dreambooth.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td> <td align="left"><a href="https://kaggle.com/kernels/welcome?src=https://github.com/huggingface/diffusion-models-class/blob/main/hackathon/dreambooth.ipynb" rel="nofollow"><img src="https://kaggle.com/static/images/open-in-kaggle.svg" alt="Kaggle"/></a></td> <td align="left"><a href="https://console.paperspace.com/github/huggingface/diffusion-models-class/blob/main/hackathon/dreambooth.ipynb" rel="nofollow"><img src="https://assets.paperspace.io/img/gradient-badge.svg" alt="Gradient"/></a></td> <td align="left"><a href="https://studiolab.sagemaker.aws/import/github/huggingface/diffusion-models-class/blob/main/hackathon/dreambooth.ipynb" rel="nofollow"><img src="https://studiolab.sagemaker.aws/studiolab.svg" alt="Open In SageMaker Studio Lab"/></a></td></tr> <tr><td align="left">Stable Diffusion Deep Dive</td> <td align="left"><a href="https://colab.research.google.com/github/fastai/diffusion-nbs/blob/master/Stable%20Diffusion%20Deep%20Dive.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td> <td align="left"><a href="https://kaggle.com/kernels/welcome?src=https://github.com/fastai/diffusion-nbs/blob/master/Stable%20Diffusion%20Deep%20Dive.ipynb" rel="nofollow"><img src="https://kaggle.com/static/images/open-in-kaggle.svg" alt="Kaggle"/></a></td> <td align="left"><a href="https://console.paperspace.com/github/fastai/diffusion-nbs/blob/master/Stable%20Diffusion%20Deep%20Dive.ipynb" rel="nofollow"><img src="https://assets.paperspace.io/img/gradient-badge.svg" alt="Gradient"/></a></td> <td align="left"><a href="https://studiolab.sagemaker.aws/import/github/fastai/diffusion-nbs/blob/master/Stable%20Diffusion%20Deep%20Dive.ipynb" rel="nofollow"><img src="https://studiolab.sagemaker.aws/studiolab.svg" alt="Open In SageMaker Studio Lab"/></a></td></tr></tbody>',Ee,Y,$t="At this point, you know enough to get started with the accompanying notebooks! Open them in your platform of choice using the links above. DreamBooth requires quite a lot of compute power, so if you’re using Kaggle or Google Colab make sure you set the runtime type to ‘GPU’ for the best results.",Ne,J,Tt="The ‘Stable Diffusion Introduction’ notebook is a short introduction to stable diffusion with the 🤗 Diffusers library, stepping through some basic usage examples using pipelines to generate and modify images.",ze,Q,Ct='In the DreamBooth Hackathon Notebook (in the <a href="https://github.com/huggingface/diffusion-models-class/tree/main/hackathon" rel="nofollow">hackathon folder</a>) we show how you can fine-tune SD on your own images to create a custom version of the model covering a new style or concept.',Be,Z,Dt="Finally, the ‘Stable Diffusion Deep Dive’ notebook and video break down every step in a typical generation pipeline, suggesting some novel ways to modify each stage for additional creative control.",Re,ee,Ke,te,_t='Follow the instructions in the <strong>DreamBooth</strong> notebook to train your own model for one of the specified categories. Make sure you include the example outputs in your submission so that we can choose the best models in each category! See the <a href="https://github.com/huggingface/diffusion-models-class/tree/main/hackathon" rel="nofollow">hackathon info</a> for details on prizes, GPU credits and more.',Ve,ie,We,ne,Lt='<li><p><a href="http://arxiv.org/abs/2112.10752" rel="nofollow">High-Resolution Image Synthesis with Latent Diffusion Models</a> - The paper that introduced the approach behind Stable Diffusion.</p></li> <li><p><a href="https://openai.com/blog/clip/" rel="nofollow">CLIP</a> - CLIP learns to connect text with images and the CLIP text encoder is used to transform a text prompt into the rich numerical representation used by SD. See also, <a href="https://wandb.ai/johnowhitaker/openclip-benchmarking/reports/Exploring-OpenCLIP--VmlldzoyOTIzNzIz" rel="nofollow">this article on OpenCLIP</a> for some background on recent open-source CLIP variants (one of which is used for SD version 2).</p></li> <li><p><a href="https://arxiv.org/abs/2112.10741" rel="nofollow">GLIDE: Towards Photorealistic Image Generation and Editing with Text-Guided Diffusion Models</a> an early paper demonstrating text conditioning and CFG.</p></li>',Xe,oe,St="Found more great resources? Let us know and we’ll add them to this list.",Ye,se,Je;return b=new u({props:{title:"Unit 3: Stable Diffusion",local:"unit-3-stable-diffusion",headingTag:"h1"}}),v=new u({props:{title:"Start this Unit :rocket:",local:"start-this-unit-rocket",headingTag:"h2"}}),$=new u({props:{title:"Introduction",local:"introduction",headingTag:"h2"}}),D=new u({props:{title:"Latent Diffusion",local:"latent-diffusion",headingTag:"h2"}}),M=new u({props:{title:"Text Conditioning",local:"text-conditioning",headingTag:"h2"}}),F=new u({props:{title:"Classifier-free Guidance",local:"classifier-free-guidance",headingTag:"h2"}}),E=new u({props:{title:"Other Types of Conditioning: Super-Resolution, Inpainting and Depth-to-Image",local:"other-types-of-conditioning-super-resolution-inpainting-and-depth-to-image",headingTag:"h2"}}),R=new u({props:{title:"Fine-Tuning with DreamBooth",local:"fine-tuning-with-dreambooth",headingTag:"h2"}}),W=new u({props:{title:"Hands-On Notebook",local:"hands-on-notebook",headingTag:"h2"}}),ee=new u({props:{title:"Project Time",local:"project-time",headingTag:"h2"}}),ie=new u({props:{title:"Some Additional Resources",local:"some-additional-resources",headingTag:"h2"}}),{c(){c=s("meta"),le=o(),ae=s("p"),re=o(),h(b.$$.fragment),he=o(),w=s("p"),w.textContent=Ze,fe=o(),h(v.$$.fragment),me=o(),y=s("p"),y.textContent=et,de=o(),x=s("ul"),x.innerHTML=tt,pe=o(),k=s("p"),k.innerHTML=it,ge=o(),h($.$$.fragment),ue=o(),T=s("p"),T.innerHTML=nt,ce=o(),C=s("p"),C.textContent=ot,be=o(),h(D.$$.fragment),we=o(),_=s("p"),_.innerHTML=at,ve=o(),L=s("p"),L.innerHTML=st,ye=o(),S=s("p"),S.innerHTML=lt,xe=o(),H=s("p"),H.innerHTML=rt,ke=o(),h(M.$$.fragment),$e=o(),P=s("p"),P.innerHTML=ht,Te=o(),I=s("p"),I.innerHTML=ft,Ce=o(),U=s("p"),U.textContent=mt,De=o(),A=s("p"),A.innerHTML=dt,_e=o(),G=s("p"),G.textContent=pt,Le=o(),h(F.$$.fragment),Se=o(),O=s("p"),O.textContent=gt,He=o(),j=s("p"),j.innerHTML=ut,Me=o(),q=s("p"),q.innerHTML=ct,Pe=o(),h(E.$$.fragment),Ie=o(),N=s("p"),N.innerHTML=bt,Ue=o(),z=s("p"),z.innerHTML=wt,Ae=o(),B=s("p"),B.innerHTML=vt,Ge=o(),h(R.$$.fragment),Fe=o(),K=s("p"),K.innerHTML=yt,Oe=o(),V=s("p"),V.innerHTML=xt,je=o(),h(W.$$.fragment),qe=o(),X=s("table"),X.innerHTML=kt,Ee=o(),Y=s("p"),Y.textContent=$t,Ne=o(),J=s("p"),J.textContent=Tt,ze=o(),Q=s("p"),Q.innerHTML=Ct,Be=o(),Z=s("p"),Z.textContent=Dt,Re=o(),h(ee.$$.fragment),Ke=o(),te=s("p"),te.innerHTML=_t,Ve=o(),h(ie.$$.fragment),We=o(),ne=s("ul"),ne.innerHTML=Lt,Xe=o(),oe=s("p"),oe.textContent=St,Ye=o(),se=s("p"),this.h()},l(e){const t=Ft("svelte-u9bgzb",document.head);c=l(t,"META",{name:!0,content:!0}),t.forEach(i),le=a(e),ae=l(e,"P",{}),Ht(ae).forEach(i),re=a(e),f(b.$$.fragment,e),he=a(e),w=l(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1udphu6"&&(w.textContent=Ze),fe=a(e),f(v.$$.fragment,e),me=a(e),y=l(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1hcxnu9"&&(y.textContent=et),de=a(e),x=l(e,"UL",{"data-svelte-h":!0}),r(x)!=="svelte-1tybmmi"&&(x.innerHTML=tt),pe=a(e),k=l(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-1ppoip6"&&(k.innerHTML=it),ge=a(e),f($.$$.fragment,e),ue=a(e),T=l(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-iv3vc4"&&(T.innerHTML=nt),ce=a(e),C=l(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-11b8aqw"&&(C.textContent=ot),be=a(e),f(D.$$.fragment,e),we=a(e),_=l(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1gv7ui7"&&(_.innerHTML=at),ve=a(e),L=l(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-e5xd70"&&(L.innerHTML=st),ye=a(e),S=l(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-127lhzy"&&(S.innerHTML=lt),xe=a(e),H=l(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-1iq7lmz"&&(H.innerHTML=rt),ke=a(e),f(M.$$.fragment,e),$e=a(e),P=l(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-voph2n"&&(P.innerHTML=ht),Te=a(e),I=l(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-140glng"&&(I.innerHTML=ft),Ce=a(e),U=l(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-11nk91f"&&(U.textContent=mt),De=a(e),A=l(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-1i0o6f1"&&(A.innerHTML=dt),_e=a(e),G=l(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1vm4kwn"&&(G.textContent=pt),Le=a(e),f(F.$$.fragment,e),Se=a(e),O=l(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-yi3njo"&&(O.textContent=gt),He=a(e),j=l(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-1ib5g2j"&&(j.innerHTML=ut),Me=a(e),q=l(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-179e1g2"&&(q.innerHTML=ct),Pe=a(e),f(E.$$.fragment,e),Ie=a(e),N=l(e,"P",{"data-svelte-h":!0}),r(N)!=="svelte-hl77ya"&&(N.innerHTML=bt),Ue=a(e),z=l(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1k5dbh4"&&(z.innerHTML=wt),Ae=a(e),B=l(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-frpfa7"&&(B.innerHTML=vt),Ge=a(e),f(R.$$.fragment,e),Fe=a(e),K=l(e,"P",{"data-svelte-h":!0}),r(K)!=="svelte-1hmf65s"&&(K.innerHTML=yt),Oe=a(e),V=l(e,"P",{"data-svelte-h":!0}),r(V)!=="svelte-x4alwp"&&(V.innerHTML=xt),je=a(e),f(W.$$.fragment,e),qe=a(e),X=l(e,"TABLE",{"data-svelte-h":!0}),r(X)!=="svelte-1717hno"&&(X.innerHTML=kt),Ee=a(e),Y=l(e,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-1bflbgv"&&(Y.textContent=$t),Ne=a(e),J=l(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-1l2vkm2"&&(J.textContent=Tt),ze=a(e),Q=l(e,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-8sil09"&&(Q.innerHTML=Ct),Be=a(e),Z=l(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-137bm2"&&(Z.textContent=Dt),Re=a(e),f(ee.$$.fragment,e),Ke=a(e),te=l(e,"P",{"data-svelte-h":!0}),r(te)!=="svelte-196oghr"&&(te.innerHTML=_t),Ve=a(e),f(ie.$$.fragment,e),We=a(e),ne=l(e,"UL",{"data-svelte-h":!0}),r(ne)!=="svelte-177kal2"&&(ne.innerHTML=Lt),Xe=a(e),oe=l(e,"P",{"data-svelte-h":!0}),r(oe)!=="svelte-1wvf2ag"&&(oe.textContent=St),Ye=a(e),se=l(e,"P",{}),Ht(se).forEach(i),this.h()},h(){Mt(c,"name","hf:doc:metadata"),Mt(c,"content",qt)},m(e,t){Ot(document.head,c),n(e,le,t),n(e,ae,t),n(e,re,t),m(b,e,t),n(e,he,t),n(e,w,t),n(e,fe,t),m(v,e,t),n(e,me,t),n(e,y,t),n(e,de,t),n(e,x,t),n(e,pe,t),n(e,k,t),n(e,ge,t),m($,e,t),n(e,ue,t),n(e,T,t),n(e,ce,t),n(e,C,t),n(e,be,t),m(D,e,t),n(e,we,t),n(e,_,t),n(e,ve,t),n(e,L,t),n(e,ye,t),n(e,S,t),n(e,xe,t),n(e,H,t),n(e,ke,t),m(M,e,t),n(e,$e,t),n(e,P,t),n(e,Te,t),n(e,I,t),n(e,Ce,t),n(e,U,t),n(e,De,t),n(e,A,t),n(e,_e,t),n(e,G,t),n(e,Le,t),m(F,e,t),n(e,Se,t),n(e,O,t),n(e,He,t),n(e,j,t),n(e,Me,t),n(e,q,t),n(e,Pe,t),m(E,e,t),n(e,Ie,t),n(e,N,t),n(e,Ue,t),n(e,z,t),n(e,Ae,t),n(e,B,t),n(e,Ge,t),m(R,e,t),n(e,Fe,t),n(e,K,t),n(e,Oe,t),n(e,V,t),n(e,je,t),m(W,e,t),n(e,qe,t),n(e,X,t),n(e,Ee,t),n(e,Y,t),n(e,Ne,t),n(e,J,t),n(e,ze,t),n(e,Q,t),n(e,Be,t),n(e,Z,t),n(e,Re,t),m(ee,e,t),n(e,Ke,t),n(e,te,t),n(e,Ve,t),m(ie,e,t),n(e,We,t),n(e,ne,t),n(e,Xe,t),n(e,oe,t),n(e,Ye,t),n(e,se,t),Je=!0},p:It,i(e){Je||(d(b.$$.fragment,e),d(v.$$.fragment,e),d($.$$.fragment,e),d(D.$$.fragment,e),d(M.$$.fragment,e),d(F.$$.fragment,e),d(E.$$.fragment,e),d(R.$$.fragment,e),d(W.$$.fragment,e),d(ee.$$.fragment,e),d(ie.$$.fragment,e),Je=!0)},o(e){p(b.$$.fragment,e),p(v.$$.fragment,e),p($.$$.fragment,e),p(D.$$.fragment,e),p(M.$$.fragment,e),p(F.$$.fragment,e),p(E.$$.fragment,e),p(R.$$.fragment,e),p(W.$$.fragment,e),p(ee.$$.fragment,e),p(ie.$$.fragment,e),Je=!1},d(e){e&&(i(le),i(ae),i(re),i(he),i(w),i(fe),i(me),i(y),i(de),i(x),i(pe),i(k),i(ge),i(ue),i(T),i(ce),i(C),i(be),i(we),i(_),i(ve),i(L),i(ye),i(S),i(xe),i(H),i(ke),i($e),i(P),i(Te),i(I),i(Ce),i(U),i(De),i(A),i(_e),i(G),i(Le),i(Se),i(O),i(He),i(j),i(Me),i(q),i(Pe),i(Ie),i(N),i(Ue),i(z),i(Ae),i(B),i(Ge),i(Fe),i(K),i(Oe),i(V),i(je),i(qe),i(X),i(Ee),i(Y),i(Ne),i(J),i(ze),i(Q),i(Be),i(Z),i(Re),i(Ke),i(te),i(Ve),i(We),i(ne),i(Xe),i(oe),i(Ye),i(se)),i(c),g(b,e),g(v,e),g($,e),g(D,e),g(M,e),g(F,e),g(E,e),g(R,e),g(W,e),g(ee,e),g(ie,e)}}}const qt='{"title":"Unit 3: Stable Diffusion","local":"unit-3-stable-diffusion","sections":[{"title":"Start this Unit :rocket:","local":"start-this-unit-rocket","sections":[],"depth":2},{"title":"Introduction","local":"introduction","sections":[],"depth":2},{"title":"Latent Diffusion","local":"latent-diffusion","sections":[],"depth":2},{"title":"Text Conditioning","local":"text-conditioning","sections":[],"depth":2},{"title":"Classifier-free Guidance","local":"classifier-free-guidance","sections":[],"depth":2},{"title":"Other Types of Conditioning: Super-Resolution, Inpainting and Depth-to-Image","local":"other-types-of-conditioning-super-resolution-inpainting-and-depth-to-image","sections":[],"depth":2},{"title":"Fine-Tuning with DreamBooth","local":"fine-tuning-with-dreambooth","sections":[],"depth":2},{"title":"Hands-On Notebook","local":"hands-on-notebook","sections":[],"depth":2},{"title":"Project Time","local":"project-time","sections":[],"depth":2},{"title":"Some Additional Resources","local":"some-additional-resources","sections":[],"depth":2}],"depth":1}';function Et(Qe){return Ut(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Rt extends At{constructor(c){super(),Gt(this,c,Et,jt,Pt,{})}}export{Rt as component};
